]> arthur.barton.de Git - ngircd-alex.git/blobdiff - src/testsuite/start-server.sh
Debian: require "telnet" or "telnet-ssl" for building
[ngircd-alex.git] / src / testsuite / start-server.sh
index 8eef8b47d2390a9d2bb0b27523d56b5fb41f86c8..90832a39f68913d757a46320bf96fd672446944b 100755 (executable)
@@ -1,22 +1,50 @@
 #!/bin/sh
 # ngIRCd Test Suite
-# $Id: start-server.sh,v 1.7 2002/09/20 13:57:01 alex Exp $
 
-echo "      starting server ..."
+[ -z "$srcdir" ] && srcdir=`dirname $0`
 
-rm -rf logs
+# read in functions
+. ${srcdir}/functions.inc
 
-echo "This is an ngIRCd Test Server" > ngircd-test.motd
+if [ -n "$1" ]; then
+       id="$1"; shift
+else
+       id="1"
+fi
 
-./ngircd-TEST -np -f ${srcdir}/ngircd-test.conf > ngircd-test.log 2>&1 &
+echo_n "      starting server ${id} ..."
+
+# remove old logfiles, if this is the first server (ID 1)
+[ "$id" = "1" ] && rm -rf logs *.log
+
+# check weather getpid.sh returns valid PIDs. If not, don't start up the
+# test-server, because we won't be able to kill it at the end of the test.
+./getpid.sh sh > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+  echo " getpid.sh failed!"
+  exit 1
+fi
+
+# check if there is a test-server already running
+./getpid.sh T-ngircd${id} >/dev/null 2>&1
+if [ $? -eq 0 ]; then
+  echo " failure: test-server ${id} already running!"
+  exit 1
+fi
+
+# generate MOTD for test-server
+echo "This is an ngIRCd Test Server" > ngircd-test${id}.motd
+
+# starting up test-server ...
+./T-ngircd${id} -n -f ${srcdir}/ngircd-test${id}.conf $* \
+ >ngircd-test${id}.log 2>&1 &
 sleep 1
 
-PS_FLAGS=-f; PS_PIDCOL=2
-ps $PS_FLAGS > /dev/null 2>&1
-if [ $? -ne 0 ]; then PS_FLAGS=a; PS_PIDCOL=1; fi
+# validate running test-server
+pid=`./getpid.sh T-ngircd${id}`
+[ -n "$pid" ] && kill -0 $pid > /dev/null 2>&1; r=$?
 
-ps $PS_FLAGS > procs.tmp
-pid=`cat procs.tmp | grep ngircd-TEST | awk "{ print \\\$$PS_PIDCOL }"`
-[ -n "$pid" ] && kill -0 $pid > /dev/null 2>&1 || exit 1
+[ $r -eq 0 ] && echo " ok." || echo " failure!"
+exit $r
 
 # -eof-